#include <dirent.h>     //DIR* __cdecl __MINGW_NOTHROW opendir (const char*);
            //struct dirent* __cdecl __MINGW_NOTHROW readdir (DIR*);
            //int __cdecl __MINGW_NOTHROW closedir (DIR*);
//#include <bits/stat.h>
#include <sys/stat.h>   //_CRTIMP int __cdecl __MINGW_NOTHROW  _stati64(const char *, struct _stati64 *);
#include <string.h>     //char * __cdecl strchr (const char * string, int ch)
#include <time.h>   //_CRTIMP char* __cdecl __MINGW_NOTHROW     ctime (const time_t*);

const int IS_DIR_FLAG = 1, IS_FILE_FLAG = 2;
 
static DIR *dirPointer;
struct dirent *next_entry;
struct stat64 statbuf_64; //struct _stati64 statbuf_64;
 
int MINGW_opendir (char * path) {
    dirPointer = opendir(path);
    if (dirPointer==NULL) return 0; //On error, NULL is returned,...
    return -1;
}

int MINGW_readdir (char* file_name, long long* file_size, int* flags, char* LastStatusChange, char* LastFileAccess, char* LastFileModification) {
    next_entry = readdir(dirPointer);
    if (next_entry==NULL) return 0;
    //https://man7.org/linux/man-pages/man3/readdir.3.html
    //struct dirent {
    //...
    //char d_name[256]; /* Null-terminated filename */
    //};

        stat64(next_entry->d_name, &statbuf_64);//_stati64(next_entry->d_name, &statbuf_64);
    //return strlen(next_entry->d_name);
    //strcpy(file_name, next_entry->d_name);
     memcpy(file_name, next_entry->d_name, 256);
    *file_size = statbuf_64.st_size;
    *flags = 0;
    if (S_ISDIR(statbuf_64.st_mode)) *flags = IS_DIR_FLAG;
    if (S_ISREG(statbuf_64.st_mode)) *flags = IS_FILE_FLAG;
    //strcpy(LastStatusChange, ctime(&statbuf_64.st_ctime)); 
    //strcpy(LastFileAccess, ctime(&statbuf_64.st_atime)); 
    //strcpy(LastFileModification, ctime(&statbuf_64.st_mtime)); // BUGFIX since r5++++, in fact this is the CULPRIT.   ]---+
    //                                                                                                                      |
     memcpy(LastFileModification, ctime((const time_t*)&statbuf_64.st_mtime), 24); // BUGFIX since r5++++, in fact this is the CULPRIT.]<--+ !!! However with -O3, QB64 blocks right after invoking this function ???
}
 
int MINGW_closedir () {
    return closedir(dirPointer); // The closedir() function returns 0 on success.  On error, -1 is returned,...
}

// 'PoolToHousePathS_REALsize' serves as function exit value - if 0 then POOL is not filled somehow, probably due to overflow
void MINGW_OpenReadCloseDIR (char *basePath, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize) {
    char path[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int flags;

    *Entries=0;
    *PoolToHousePathS_REALsize=0;
    dir = opendir(basePath);
    if (!dir) return;
while ((dp = readdir(dir)) != NULL) {
// each record has to contain these fields:
// [1byte-type][8bytes-size][24bytes-time][256bytes-name] or 289 bytes

            //strcpy(path, basePath);
            //strcat(path, dp->d_name);
    stat64(dp->d_name, &statbuf_64);//_stati64(dp->d_name, &statbuf_64);
    //return strlen(dp->d_name);
    //strcpy(file_name, dp->d_name);
    flags = 0;
    if (S_ISDIR(statbuf_64.st_mode)) flags = IS_DIR_FLAG;
    if (S_ISREG(statbuf_64.st_mode)) flags = IS_FILE_FLAG;
    if (flags) {
    memcpy(path+0, &flags, 1);
    memcpy(path+1, &statbuf_64.st_size, 8);
    memcpy(path+1+8, ctime((const time_t*)&statbuf_64.st_mtime), 24);
    memcpy(path+1+8+24, dp->d_name, 256);

            //printf("%s\n", path); //This goes to console
                        if ( *PoolToHousePathS_REALsize + 289 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, path, 289);
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + 289;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
                        *Entries=*Entries+1;
    } //if (flags) {
} //while ((dp = readdir(dir)) != NULL) {
    closedir(dir);
    return;
}

//Function strchrKAZE~&& (ByVal buf1 As _Offset, Byval byteSOUGHT As integer)
uint64_t strchrKAZE (char * buf1, uint16_t byteSOUGHT)
{
return (uint64_t)(strchr(buf1, byteSOUGHT)-buf1);
}
//char * __cdecl strchr (const char * string, int ch)
//char *strchr(string, c) - search a string for a character
//
//Purpose:
//       Searches a string for a given character, which may be the
//       null character '\0'.
//
//Entry:
//       char *string - string to search in
//       char c - character to search for
//
//Exit:
//       returns pointer to the first occurence of c in string
//       returns NULL if c does not occur in string
